require 'page_objects/wallhack_ws_demo_page'
require 'watir-webdriver'

class QA_CTX_Backend_Helper

  WALLHACK_HOST = 'wallhack.qa.ctx.ef.com'

  def self.update_taught_lessons_timestamps(period, lesson_id, user_email)
    case period
      when 'This week'
        start_date = Date.today
      when 'Last week'
        start_date = Date.today-7
      when 'This month'
        start_date = Date.today
      when 'Last month'
        start_date = Date.today<<1
      when '2 month ago'
        start_date = Date.today<<2
      when '3 month ago'
        start_date = Date.today<<3
      when '4 month ago'
        start_date = Date.today<<4
      when 'Older'
        start_date = Date.today<<6
      else
        start_date = Date.today<<7
    end

    http2 = Net::HTTP.new(WALLHACK_HOST)
    path = '/ws/login?user_email=' + user_email.sub('+', '%2B')
    next_path = '/lessons/' + lesson_id

    r = http2.get(path)
    cookie = {'Cookie'=>r.to_hash['set-cookie'].collect{|ea|ea[/^.*?;/]}.join}

    r2 = http2.get(next_path,cookie)
    #r2.body.slice! '"version": 1, '
    parsed = JSON.parse(r2.body)
    parsed["metadata"]["started"] = start_date.to_s + 'T14:24:05.229770+00:00'

    uri = URI('http://'+WALLHACK_HOST+'/lessons/' + lesson_id)

    #delete_req = Net::HTTP::Delete.new(uri)
    #delete_req['Cookie'] = r['Set-Cookie']
    #response = http2.request(delete_req)

    req = Net::HTTP::Put.new(uri)
    req.body = parsed.to_json
    req.content_type = 'multipart/form-data'
    req['Cookie'] = r['Set-Cookie']
    response = http2.request(req)
  end

  def self.stop_all_lessons(user_email)
    browser = Watir::Browser.new :phantomjs
    wallhack_demo_page = Wallhack_WS_Demo_Page.new(browser)
    wallhack_demo_page.load_page(user_email)
    sleep(25)
    wallhack_demo_page.stop_all_lessons
    sleep(25)
    browser.close
  end

end


#CTX_Backend_Helper.stop_all_lessons('ctx.twa+4@gmail.com')